/*
   FILNAME:    

   PURPOSE:                  

   CREATED BY:    Per Ghosh            
   ENVIRONMENT:	Visual C++


INFO:
*/

#ifndef __PGSTORAGE_H_
#define __PGSTORAGE_H_

#ifndef STORAGE_T_RW_SE
   #define STORAGE_T_RW_SE     STGM_TRANSACTED | STGM_READWRITE | STGM_SHARE_EXCLUSIVE
   #define STORAGE_D_RW_SE     STGM_DIRECT | STGM_READWRITE | STGM_SHARE_EXCLUSIVE
#endif

class CPGStream;

class CPGStorage : public CObject
{
	DECLARE_DYNAMIC(CPGStorage)

public:
	CPGStorage();           
	CPGStorage( LPCSTR pszName );
	CPGStorage( const WCHAR* pwName );

   virtual ~CPGStorage();

// Attributes                    
public:
   static HRESULT m_hResult;

	IStorage*   m_pIStorage;

private:
   WCHAR*      m_pwName;               // This storagename

   CPGStorage* m_pStorageParent;       // Parentstorage if not root storage

   CObArray    m_arrayToStorage;       // Substorages that belong to this storage

   CPGStream*  m_pstreamActive;    
   CObArray    m_arrayToStream;        // Files that are connected to this storage

// Get/Set
public:
   const WCHAR* GetName() { return m_pwName; }

// Operations
public:
	CPGStorage* CreateStorage( WCHAR* pwName, DWORD dwFlags = STORAGE_T_RW_SE );
	CPGStorage* OpenStorage( WCHAR* pwName, DWORD dwFlags = STORAGE_T_RW_SE );

	CPGStream* CreateStream( WCHAR* pwName, DWORD dwFlags = STORAGE_D_RW_SE );
	CPGStream* OpenStream( WCHAR* pwName, DWORD dwFlags = STORAGE_D_RW_SE );

   int Dir( CPtrArray& ptrarrayToSTATSTG, DWORD dwType, DWORD dwMaxElements );

   BOOL Commit( DWORD dwFlags = STGC_DEFAULT );

// Implementation
public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

};

#endif